//  File: ConvertTemperatures.java
//  Convert between Fahrenheit and Celsius or vice-versa
//    using a null layout

import java.awt.*;
import java.awt.event.*;

class ConvertTemperatures extends Frame
  implements ActionListener, WindowListener
{ Label[] Directions;
  TextField Fahrenheit, Celsius;
  Button Clear; // Why must the TextFields and Button be global?

  ConvertTemperatures(String s)
  { // Send the window title to the Frame
    super(s);
    // Set size. Need to make it large enough so display works
    setSize(180,180);
    // Use a BorderLayout
    setLayout(null);
    // Listen for the x
    addWindowListener(this);
    // Add prompt; need panel since we need 2 labels to hold it
    Directions = new Label[2];
    Directions[0]=new Label("Enter temperature to convert");
    Directions[1]=new Label("in appropriate box:");
    Directions[0].setBounds(10,25,200,15);
    Directions[1].setBounds(10,40,200,15);
    add(Directions[0]);
    add(Directions[1]);

    // Make and add a label to the Frame
    Label FahrText=new Label("Fahrenheit:");
    FahrText.setBounds(5,70,100,20);
    add(FahrText);
    // Set up the TextField
    Fahrenheit = new TextField(2);
    Fahrenheit.setBounds(110,70,60,20);
    add(Fahrenheit);
    // Need to listen for the event (only possible: carriage return)
    Fahrenheit.addActionListener(this);
    // Same for the Celsius stuff
    Label CelsText=new Label("Celsius:   ");
    CelsText.setBounds(5,100,100,20);
    add(CelsText);
    Celsius = new TextField(2);
    Celsius.setBounds(110,100,60,20);
    add(Celsius);
    Celsius.addActionListener(this);
    // Need a Button so we can clear the TextFields
    Clear=new Button("Clear Temperatures");
    Clear.setBounds(30,150,120,25);
    add(Clear);
    Clear.addActionListener(this);
    // Make it visible
    setVisible(true);
  }

  public void windowClosed(WindowEvent event) {}
  public void windowDeiconified(WindowEvent event) {}
  public void windowIconified(WindowEvent event) {}
  public void windowActivated(WindowEvent event) {}
  public void windowDeactivated(WindowEvent event) {}
  public void windowOpened(WindowEvent event) {}
  public void windowClosing(WindowEvent event) { System.exit(0); }

  public void actionPerformed(ActionEvent event)
  {if (event.getSource()==Fahrenheit) {
      int f = Integer.parseInt(Fahrenheit.getText().trim());
      long c = Math.round(5.0*(f - 32)/9.0);
      Fahrenheit.setText(f+"\u00B0F");
      Celsius.setText(c + "\u00B0C");
   }
   else if (event.getSource()==Celsius) {
      int c = Integer.parseInt(Celsius.getText().trim());
      long f = Math.round(9.0/5.0*c + 32);
      Fahrenheit.setText(f + "\u00B0F");
      Celsius.setText(c + "\u00B0C");
   }
   else if (event.getSource()==Clear) {
      Fahrenheit.setText("");
      Celsius.setText("");
      // Put the cursor in the Celsius TextField
      Celsius.requestFocus();
   }
  }
}

class TestConvertTemperatures
{ public static void main(String[] args)
  { new ConvertTemperatures("Fahrenheit <--> Celsius Conversion");
  }
}
